diff -p -r -U3 -N -X /home/gpc/p/script/gpcdiff.exclude orig/declarations.c p/declarations.c
--- orig/declarations.c	Wed Apr 30 17:38:20 2003
+++ p/declarations.c	Thu May  8 00:39:17 2003
@@ -2644,7 +2659,7 @@ pascal_shadow_record_fields (element, id
         elem_type = p_build_type_variant (elem_type, 1, TYPE_VOLATILE (elem_type));
       rec_addr = make_new_variable ("with_element", build_pointer_type (elem_type));
       expand_expr_stmt (build_modify_expr (rec_addr, NOP_EXPR,
-                          build_unary_op (ADDR_EXPR, element, 0)));
+                          build_unary_op (ADDR_EXPR, element, 1)));
       element = build_indirect_ref (rec_addr, "`with'");
     }
 
diff -p -r -U3 -N -X /home/gpc/p/script/gpcdiff.exclude orig/expressions.c p/expressions.c
--- orig/expressions.c	Tue Apr 29 17:12:16 2003
+++ p/expressions.c	Wed May  7 23:32:12 2003
@@ -2865,8 +2865,15 @@ build_unary_op (code, xarg, noconvert)
       if (TREE_CODE (arg) == ARRAY_REF)
         {
           tree index, array = TREE_OPERAND (arg, 0);
-          if (!mark_addressable (array))
+
+          tree t = array;
+          if (noconvert)
+            /* Don't let mark_addressable do this, it would complain about packed fields */
+            while (TREE_CODE (t) == COMPONENT_REF)
+              t = TREE_OPERAND (t, 0);
+          if (!mark_addressable (t))
             return error_mark_node;
+
           if (!noconvert && PASCAL_TYPE_PACKED (TREE_TYPE (TREE_OPERAND (arg, 0))))
             chk_dialect ("this use of packed array components is", B_D_M_PASCAL);
 
diff -p -r -U3 -N -X /home/gpc/p/script/gpcdiff.exclude orig/types.c p/types.c
--- orig/types.c	Wed Apr 30 10:57:24 2003
+++ p/types.c	Thu May  8 00:22:10 2003
@@ -2298,8 +2298,14 @@ build_array_ref (array, index)
       if (TREE_CODE (index) != INTEGER_CST
           || (TYPE_SIZE (TREE_TYPE (TREE_TYPE (array)))
               && TREE_CODE (TYPE_SIZE (TREE_TYPE (TREE_TYPE (array)))) != INTEGER_CST))
-        if (!mark_addressable (array))
-          return error_mark_node;
+        {
+          tree t = array;
+          /* Don't let mark_addressable do this, it would complain about packed fields */
+          while (TREE_CODE (t) == COMPONENT_REF)
+            t = TREE_OPERAND (t, 0);
+          if (!mark_addressable (t))
+            return error_mark_node;
+        }
 
       if (pedantic && !lvalue)
         {
